SystemOrganization addCategory: #'Pier-Design'!

PRChangeCommand subclass: #PRDesignCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Design'!

!PRDesignCommand commentStamp: 'lr 11/5/2007 21:41' prior: 0!
Command to edit the design of the current page. This is a shortcut of the normal edit command on the associated environment pages.!

!PRDesignCommand class methodsFor: 'accessing' stamp: 'tg 11/14/2007 16:56'!
accessKey
	^ $d! !

!PRDesignCommand class methodsFor: 'testing' stamp: 'lr 11/5/2007 21:44'!
isAbstract
	^ false! !

!PRDesignCommand class methodsFor: 'accessing' stamp: 'lr 11/5/2007 21:13'!
label
	^ 'Edit Design'! !

!PRDesignCommand methodsFor: 'private' stamp: 'lr 3/2/2008 11:02'!
description
	| description |
	description := MAContainer new.
	description addAll: (self 
		descriptionsForGroup: 'Environment'
		selector: #environment).
	self structure styleSheets withIndexDo: [ :each :index |
		description addAll: (self 
			descriptionsForGroup: 'Style Sheets'
			selector: #styleSheets
			index: index) ].
	^ description! !

!PRDesignCommand methodsFor: 'private' stamp: 'lr 11/14/2007 20:57'!
descriptionsForGroup: aString selector: aSelector
	^ self descriptionsForGroup: aString selector: aSelector index: nil! !

!PRDesignCommand methodsFor: 'private' stamp: 'lr 3/2/2008 11:09'!
descriptionsForGroup: aString selector: aSelector index: anInteger
	"Now this is truly and utterly ugly. Don't look at it, ok?"
	
	| accessor |
	accessor := MASelectorAccessor selector: aSelector.
	accessor := anInteger isNil 
		ifTrue: [ PRDocumentAccessor on: accessor ]
		ifFalse: [ 
			MAChainAccessor
				accessor: accessor 
				next: (MADictionaryAccessor key: anInteger) ].
	^ Array 
		with: (PRStructureDescription new
			accessor: accessor;
			label: 'Location';
			group: aString;
			beReadonly;
			yourself)
		with: ((anInteger isNil 
				ifTrue: [ PRDocumentDescription ]
				ifFalse: [ MAMemoDescription ]) new
			instVarNamed: 'accessor' put: (MAChainAccessor
				accessor: accessor
				next: (MASelectorAccessor selector: (anInteger isNil
					ifTrue: [ #document ]
					ifFalse: [ #contents ])));
			label: 'Contents';
			group: aString;
			yourself)! !

!PRDesignCommand methodsFor: 'events' stamp: 'lr 3/2/2008 11:08'!
doExecute
	super doExecute.
	self structure styleSheets 
		do: [ :each | each file mimetype: 'text/css' ]! !
